print(format("SearchEx AddOn loaded, version %s", GetAddOnMetadata("SearchEx", "Version") ))

local eFrame,virgin,setId,setVal

local function checkStat(txt, sName)
	local sLine = string.match(txt, "%+([0-9,]+) "..sName) or "x" 
	if sLine ~= "x" then
		sLine = string.gsub(sLine, ",", "")
		return tonumber(sLine)
	end
	return 0
end

eFrame = CreateFrame("Frame", "EventFrame", UIParent)
local eList = {"ADDON_LOADED", "PLAYER_ENTERING_WORLD"}
for k = 1, table.getn(eList) do eFrame:RegisterEvent(eList[k]) end

local function moveFrame(fr, x, y)
	local point, relativeTo, relativePoint, xOffset, yOffset = fr:GetPoint()
	fr:SetPoint(point, relativeTo, relativePoint, xOffset + x, yOffset + y)
end

local AHDDM_Items = { "Any",
	"Stamina", "Strength", "Agility", "Intellect",
	"Critical", "Haste", "Mastery", "Multistrike", "Versatility",
	"Leech", "Speed"
} 

local function AH_DDM_OnClick(self)
	setId = self:GetID()
	UIDropDownMenu_SetSelectedID(AH_DDM, setId)
	--print(AHDDM_Items[setId])
end
 
local function AH_DDM_Init(self, level)
	local info = UIDropDownMenu_CreateInfo()
	for k,v in pairs(AHDDM_Items) do
	  info = UIDropDownMenu_CreateInfo()
	  info.text = v
	  info.value = v
	  info.func = AH_DDM_OnClick
	  UIDropDownMenu_AddButton(info, level)
	end
end

local function filterItems()
	if setId == 1 then
		for k = 1, 8 do _G["BrowseButton"..k]:SetAlpha(1) end
		return
	end
	local off = FauxScrollFrame_GetOffset(BrowseScrollFrame)
	for k = 1, 8 do 
		AH_GTT:SetAuctionItem("list", k + off)
		_G["BrowseButton"..k]:SetAlpha(0.3)
		local txt, stat
		local numLines = AH_GTT:NumLines()
		for i = 2, numLines do
			txt = _G["AH_GTTTextLeft"..i]:GetText()
			stat = checkStat(txt,AHDDM_Items[setId])
			if stat > setVal then
				_G["BrowseButton"..k]:SetAlpha(1)
				break
			end
		end
	end
end

local function alterAH()

	if not AH_GTT then
		CreateFrame("GameTooltip", "AH_GTT", nil, "GameTooltipTemplate")
		AH_GTT:SetOwner(WorldFrame, "ANCHOR_NONE")
	end

	moveFrame(BrowsePrevPageButton, 52, 0)
	moveFrame(BrowseDropDown, -5, 0)
	moveFrame(IsUsableCheckButton, 145, 0)
	
	UIDropDownMenu_SetWidth(BrowseDropDown, 90)
	UIDropDownMenu_SetButtonWidth(BrowseDropDown, 114)
	
	if not AH_DDM then
	   CreateFrame("Button", "AH_DDM", AuctionFrame, "UIDropDownMenuTemplate")
	end
	
	local point, relativeTo, relativePoint, xOffset, yOffset = BrowseDropDown:GetPoint()
	AH_DDM:ClearAllPoints()
	AH_DDM:SetPoint(point, relativeTo, relativePoint, xOffset + 110, yOffset)
	 
	UIDropDownMenu_Initialize(AH_DDM, AH_DDM_Init)
	UIDropDownMenu_SetWidth(AH_DDM, 80)
	UIDropDownMenu_SetButtonWidth(AH_DDM, 104)
	UIDropDownMenu_SetSelectedID(AH_DDM, 1); setId = 1;
	UIDropDownMenu_JustifyText(AH_DDM, "LEFT")
	AH_DDM:Show()
	
	if not AH_SL then
	   CreateFrame("EditBox", "AH_SL", AuctionFrame, "InputBoxTemplate")
	end
	AH_SL:SetWidth(40)
	AH_SL:SetHeight(20)
	AH_SL:SetPoint(point, relativeTo, relativePoint, xOffset + 235, yOffset - 3)
	AH_SL:SetAutoFocus(false)
	AH_SL:SetNumeric(true)
	setVal = 0
	AH_SL:SetScript("OnKeyUp", function(self, key)
		setVal = tonumber(AH_SL:GetText())
		if setVal == nil then setVal = 0 end
	end)

	AH_SL:Show()
end

local total = 0
function eFrame:OnUpdate(elapsed)
	total = total + elapsed
	if total >= 1/20 then
		if AuctionFrame then
			if virgin == 1 then 
				virgin = 0
				alterAH()
			end
			filterItems()
		end
		total = 0
	end
end

function eFrame:OnEvent(event, ...)
	if event == "ADDON_LOADED" then
		if select(1, ...) == "SearchEx" then
			virgin = 1
			eFrame:SetScript("OnUpdate", eFrame.OnUpdate)
		end
	end
end

eFrame:SetScript("OnEvent", eFrame.OnEvent)

--print("end")























